package nl.tue.id.zoo.util;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Life {

    static final long night = 5 * 1000;
    static final long day = 5 * 1000;
    static final long daynnight = day + night;
    static final long year = 5 * daynnight;
    static final long tick = 1000;

    private long age = 0;
    private Timer t = new Timer();
    private LifeHolder lifeHolder;

    public Life(LifeHolder lifeHolder) {
        this.lifeHolder = lifeHolder;
        init();
    }

    private void init() {
        t.scheduleAtFixedRate(new SleepTask(),
                              new Date(((
                                      (
                                              new Date() //* now
                                      ).getTime() / daynnight) + 1) * daynnight
                              ) // the time of "next day"
                              , daynnight);
        t.scheduleAtFixedRate(new GetupTask(),
                      new Date(((
                              (
                                      new Date() //* now
                              ).getTime() / daynnight) + 1) * daynnight
                               + night
                      )
                      , daynnight);

        t.schedule(new BirthdayTask(),
                   year, //after one year, the first birthday
                   year  //celebrate it every year
                );
        t.schedule(new TickTask(), 0L, tick);
    }

    public long howOldAreYou() {
        return age;
    }

    public void die() {
        t.cancel();
    }

    class SleepTask extends TimerTask {
        public void run() {
            lifeHolder.Sleep();
        }
    }


    class GetupTask extends TimerTask {
        public void run() {
            lifeHolder.Getup();
        }
    }


    class BirthdayTask extends TimerTask {
        public void run() {
            lifeHolder.Birthday();
            age = age + 1;
        }
    }


    class TickTask extends TimerTask {
        public void run() {
            lifeHolder.LifeGoesOn();
        }
    }

}
