package nl.tue.id.zoo.animal;

import nl.tue.id.zoo.food.*;
import nl.tue.id.zoo.util.*;
import nl.tue.id.zoo.ui.*;
import nl.tue.id.zoo.ui.AnimalBody;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Cat extends Mammal implements EventListener {
    public Cat() {
    }

    public void setBirthWeight() {
        this.setWeight(2);
    }

    public void move() {
        say("Cat running...");
    }

    public void say(String words) {
        super.say(miaow(words));
    }

    public String miaow(String words) {
        return "Miaow!!!!" + words;
    }

    public void eat(Food food) {
        if (food instanceof CatFood) {
            setWeight(getWeight() + food.getNutritionFactor() * .1 +
                      food.getWeight() * .0001);
        }
    }

    public void receiveEvent(Event event) {
        if (event instanceof DogBarkingEvent) {
            say("I am so scared! A dog is really barking!");
             if (this.getBody() != null) {
                    ((CatBody) getBody()).shaking();
                }
            }
    }

    protected AnimalBody createBody() {
        return new CatBody();
    }


}
