package nl.tue.id.zoo.animal;

import nl.tue.id.zoo.food.*;
import nl.tue.id.zoo.*;
import nl.tue.id.zoo.ui.*;
import nl.tue.id.zoo.util.*;
import nl.tue.id.zoo.ui.AnimalBody;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Dog extends Mammal {
    public Dog() {
    }

    public void setBirthWeight(){
        this.setWeight(10);
    }

    public void move() {
        say("Dog jumping...");
    }

    public void say(String words) {
        super.say(bark(words));
        Zoo.getTheZoo().dispatchEvent(new DogBarkingEvent(this));
    }

    public String bark(String words) {
        return "Woof!!!!!" + words;
    }


    public void eat(Food food) {
        if(food instanceof DogFood){
            setWeight(getWeight()+food.getNutritionFactor()*.2+food.getWeight()*.001);
        }
    }

    protected AnimalBody createBody() {
        return new DogBody();
    }
}
