package nl.tue.id.zoo.ui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import nl.tue.id.zoo.food.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class BuffetTable extends JFrame {
    JRadioButton ahBeefStrips = new JRadioButton();
    JRadioButton ahKiteKat = new JRadioButton();
    JRadioButton homeMadeMix = new JRadioButton();
    FlowLayout flowLayout1 = new FlowLayout();

    static BuffetTable table = null;

    private BuffetTable() {
        try {
            jbInit();
            this.setVisible(true);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public static BuffetTable getTheTable() {
        if (table == null) {
            table = new BuffetTable();
        }
        return table;
    }



    private void jbInit() throws Exception {
        getContentPane().setLayout(flowLayout1);
        ahBeefStrips.setToolTipText("only for dogs!");
        ahBeefStrips.setSelected(true);
        ahBeefStrips.setText("AHBeefStrips");
        ahBeefStrips.addActionListener(new
                                       BuffetTable_ahBeefStrips_actionAdapter(this));
        ahKiteKat.setToolTipText("");
        ahKiteKat.setText("AHKitekat");
        ahKiteKat.addActionListener(new
                                    BuffetTable_ahKiteKat_actionAdapter(this));
        homeMadeMix.setToolTipText("for dogs and cats");
        homeMadeMix.setText("HomeMadeMix");
        homeMadeMix.addActionListener(new BuffetTable_homeMadeMix_actionAdapter(this));
        this.setTitle("Buffet");
        this.addWindowListener(new BuffetTable_this_windowAdapter(this));
        this.getContentPane().add(ahBeefStrips, null);
        this.getContentPane().add(ahKiteKat, null);
        this.getContentPane().add(homeMadeMix, null);
        this.setSize(new Dimension(331, 76));
        this.setLocation(300,0);

    }

    public void ahKiteKat_actionPerformed(ActionEvent e) {
        ahBeefStrips.setSelected(false);
        ahKiteKat.setSelected(true);
        homeMadeMix.setSelected(false);

    }

    public void ahBeefStrips_actionPerformed(ActionEvent e) {
        ahBeefStrips.setSelected(true);
        ahKiteKat.setSelected(false);
        homeMadeMix.setSelected(false);
    }

    public void homeMadeMix_actionPerformed(ActionEvent e) {
        ahBeefStrips.setSelected(false);
        ahKiteKat.setSelected(false);
        homeMadeMix.setSelected(true);
    }

    public Food whatHasBeenChoosen(){
        if(ahBeefStrips.isSelected()) return new AHBeefStripsForDogs();
        if(ahKiteKat.isSelected()) return new AHKitekat();
        return new HomeMadeMix();
    }

    public void this_windowClosed(WindowEvent e) {

    }

    public void this_windowClosing(WindowEvent e) {
        System.exit(0);
    }
}


class BuffetTable_this_windowAdapter extends WindowAdapter {
    private BuffetTable adaptee;
    BuffetTable_this_windowAdapter(BuffetTable adaptee) {
        this.adaptee = adaptee;
    }

    public void windowClosed(WindowEvent e) {
        adaptee.this_windowClosed(e);
    }

    public void windowClosing(WindowEvent e) {
        adaptee.this_windowClosing(e);
    }
}


class BuffetTable_ahBeefStrips_actionAdapter implements ActionListener {
    private BuffetTable adaptee;
    BuffetTable_ahBeefStrips_actionAdapter(BuffetTable adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.ahBeefStrips_actionPerformed(e);
    }
}


class BuffetTable_ahKiteKat_actionAdapter implements ActionListener {
    private BuffetTable adaptee;
    BuffetTable_ahKiteKat_actionAdapter(BuffetTable adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.ahKiteKat_actionPerformed(e);
    }
}


class BuffetTable_homeMadeMix_actionAdapter implements ActionListener {
    private BuffetTable adaptee;
    BuffetTable_homeMadeMix_actionAdapter(BuffetTable adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.homeMadeMix_actionPerformed(e);
    }
}
